Package: RcppSimdJson
Type: Package
Title: 'Rcpp' Bindings for the 'simdjson' Header-Only Library for
        'JSON' Parsing
Version: 0.1.15
Date: 2026-01-14
Authors@R: c(person("Dirk", "Eddelbuettel", role = c("aut", "cre"), email = "edd@debian.org",
                    comment = c(ORCID = "0000-0001-6419-907X")),
             person("Brendan", "Knapp", role = "aut",
                    comment = c(ORCID = "0000-0003-3284-4972")),
             person("Daniel", "Lemire", role = "aut",
                    comment = c(ORCID = "0000-0003-3306-6922")))
Description: The 'JSON' format is ubiquitous for data interchange, and the
 'simdjson' library written by Daniel Lemire (and many contributors) provides a
 high-performance parser for these files which by relying on parallel 'SIMD'
 instruction manages to parse these files as faster than disk speed. See the
 <doi:10.48550/arXiv.1902.08318> paper for more details about 'simdjson'.  This
 package parses 'JSON' from string, file, or remote URLs under a variety of
 settings.
License: GPL (>= 2)
Imports: Rcpp, utils
LinkingTo: Rcpp
Suggests: bit64, tinytest
URL: https://github.com/eddelbuettel/rcppsimdjson/
BugReports: https://github.com/eddelbuettel/rcppsimdjson/issues
RoxygenNote: 7.1.1
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2026-01-14 12:10:02 UTC; edd
Author: Dirk Eddelbuettel [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6419-907X>),
  Brendan Knapp [aut] (ORCID: <https://orcid.org/0000-0003-3284-4972>),
  Daniel Lemire [aut] (ORCID: <https://orcid.org/0000-0003-3306-6922>)
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Repository: CRAN
Date/Publication: 2026-01-14 12:40:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 16:30:07 UTC; unix
Archs: RcppSimdJson.so.dSYM

Package: RcppSimdJson
Type: Package
Title: 'Rcpp' Bindings for the 'simdjson' Header-Only Library for
        'JSON' Parsing
Version: 0.1.15
Date: 2026-01-14
Authors@R: c(person("Dirk", "Eddelbuettel", role = c("aut", "cre"), email = "edd@debian.org",
                    comment = c(ORCID = "0000-0001-6419-907X")),
             person("Brendan", "Knapp", role = "aut",
                    comment = c(ORCID = "0000-0003-3284-4972")),
             person("Daniel", "Lemire", role = "aut",
                    comment = c(ORCID = "0000-0003-3306-6922")))
Description: The 'JSON' format is ubiquitous for data interchange, and the
 'simdjson' library written by Daniel Lemire (and many contributors) provides a
 high-performance parser for these files which by relying on parallel 'SIMD'
 instruction manages to parse these files as faster than disk speed. See the
 <doi:10.48550/arXiv.1902.08318> paper for more details about 'simdjson'.  This
 package parses 'JSON' from string, file, or remote URLs under a variety of
 settings.
License: GPL (>= 2)
Imports: Rcpp, utils
LinkingTo: Rcpp
Suggests: bit64, tinytest
URL: https://github.com/eddelbuettel/rcppsimdjson/
BugReports: https://github.com/eddelbuettel/rcppsimdjson/issues
RoxygenNote: 7.1.1
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2026-01-14 12:10:02 UTC; edd
Author: Dirk Eddelbuettel [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6419-907X>),
  Brendan Knapp [aut] (ORCID: <https://orcid.org/0000-0003-3284-4972>),
  Daniel Lemire [aut] (ORCID: <https://orcid.org/0000-0003-3306-6922>)
Maintainer: Dirk Eddelbuettel <edd@debian.org>
Repository: CRAN
Date/Publication: 2026-01-14 12:40:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-05-04 20:55:19 UTC; unix
Archs: RcppSimdJson.so.dSYM

## RcppSimdJson: Rcpp Bindings for the simdjson Header Library

[![CI](https://github.com/eddelbuettel/rcppsimdjson/workflows/ci/badge.svg)](https://github.com/eddelbuettel/rcppsimdjson/actions?query=workflow%3Aci)
[![License](https://eddelbuettel.github.io/badges/GPL2+.svg)](https://www.r-project.org/Licenses/GPL-2)
[![CRAN](https://www.r-pkg.org/badges/version/RcppSimdJson)](https://cran.r-project.org/package=RcppSimdJson)
[![Dependencies](https://tinyverse.netlify.app/badge/RcppSimdJson)](https://cran.r-project.org/package=RcppSimdJson)
[![Downloads](https://cranlogs.r-pkg.org/badges/RcppSimdJson?color=brightgreen)](https://www.r-pkg.org/pkg/RcppSimdJson)
[![Code Coverage](https://codecov.io/gh/eddelbuettel/RcppSimdJson/graph/badge.svg)](https://app.codecov.io/gh/eddelbuettel/RcppSimdJson)
[![Last Commit](https://img.shields.io/github/last-commit/eddelbuettel/rcppsimdjson)](https://github.com/eddelbuettel/rcppsimdjson)

### Motivation

[simdjson](https://github.com/simdjson/simdjson) by [Daniel Lemire](https://lemire.me/en/) (with contributions by [Geoff
Langdale](https://branchfree.org/),  [John Keiser](https://github.com/jkeiser) and  [many others](https://github.com/simdjson/simdjson/graphs/contributors)) is an
engineering marvel.  Through very clever use of [SIMD instructions](https://en.wikipedia.org/wiki/SIMD),
it manages to parse JSON files faster than disc access. Wut? Yes you read that right: parallel
processing with so little overhead that the net throughput is limited only by disk speed.

Moreover, it is implemented in neat modern C++ and can be accessed as a header-only library. (Well,
one library in two files, really.)  Which makes R packaging easy and convenient and compelling. So
here we are.

For further introduction, see the [arXiv paper](https://arxiv.org/abs/1902.08318) by Langdale and Lemire (out/to appear in VLDB
Journal 28(6) as well) and/or the video of the [recent talk by Daniel Lemire at
QCon](https://www.youtube.com/watch?v=wlvKAT7SZIQ) (voted best talk).

### Example

```r
jsonfile <- system.file("jsonexamples", "twitter.json", package="RcppSimdJson")
library(RcppSimdJson)
validateJSON(jsonfile)                  # validate a JSON file
res <- fload(jsonfile)                  # parse a JSON file
```

### Comparison

A [simple file-oriented parsing benchmark][simpleBenchmark] against the other R-accessible JSON
parsers:

```r
> print(res)
Unit: microseconds
     expr       min        lq      mean   median        uq        max neval   cld
  yyjsonr   312.267   347.683   405.177   390.11   425.827    926.776   100 a
 simdjson   274.367   323.998   447.691   467.79   526.237    773.070   100 a
  jsonify  2727.874  2813.681  2952.804  2896.84  2972.852   7442.755   100  b
 jsonlite  4237.538  4435.683  4587.428  4552.38  4668.345   7082.673   100   c
  RJSONIO  9131.864  9425.515  9707.274  9599.48  9845.006  13516.616   100    d
   ndjson 91668.822 92628.357 95386.212 93192.37 94507.484 152179.095   100     e
>
```

Or in chart form, also including the [second benchmark parsing strings][simpleParseBenchmark.R]:

![](https://eddelbuettel.github.io/rcppsimdjson/rcppsimdjson_both_benchmarks.png)

### Status

All three major OSs are supported, and JSON can be parsed from file and string under a variety of
settings. A C++17 compiler is required for ease of setup (though the upstream can fall back to older
compiler; one can edit [src/Makevars](https://github.com/eddelbuettel/rcppsimdjson/blob/master/src/Makevars)
accordingly if need be).

### Contributing

Any problems, bug reports, or features requests for the package can be submitted and handled most
conveniently as [Github issues](https://github.com/eddelbuettel/rcppsimdjson/issues) in the repository.

Before submitting pull requests, it is frequently preferable to first discuss need and scope in such
an issue ticket.  See the file
[Contributing.md](https://github.com/RcppCore/Rcpp/blob/master/Contributing.md) (in the
[Rcpp](https://github.com/RcppCore/Rcpp) repo) for a brief discussion.


### See Also

For standard JSON work on R, as well as for other nicely done C++ libraries, consider these:

- [jsonlite](https://cran.r-project.org/package=jsonlite) by [Jeroen Ooms](https://github.com/jeroen) is excellent, very versatile, and probably most-widely used;
- [rapidjsonr](https://cran.r-project.org/package=rapidjsonr) and [jsonify](https://cran.r-project.org/package=jsonify) by [David Cooley](https://github.com/dcooley) bringing [RapidJSON](https://rapidjson.org/) to R;
- [ndjson](https://cran.r-project.org/package=ndjson) by [Bob Rudis](https://rud.is/b/) builds on the [JSON for Modern C++](https://github.com/nlohmann/json) library by [Niels Lohmann](https://github.com/nlohmann);
- [RJSONIO](https://cran.r-project.org/package=RJSONIO) by [Duncan Temple Lang](https://www.stat.ucdavis.edu/~duncan/) started all this but could use a little love;
- [yyjsonr](https://cran.r-project.org/package=yyjsonr) by [Mike Cheng](https://coolbutuseless.github.io/) is a more recent and performant addition based on [yyjson](https://github.com/ibireme/yyjson).

### Author

For the R package, [Dirk Eddelbuettel](https://github.com/eddelbuettel) and [Brendan
Knapp](https://github.com/knapply).

For everything pertaining to simdjson, [Daniel Lemire](https://lemire.me/en/) (and [many
contributors](https://github.com/simdjson/simdjson/graphs/contributors)).


[simpleBenchmark]: https://github.com/eddelbuettel/rcppsimdjson/blob/master/inst/examples/simpleBenchmark.R
[simpleParseBenchmark]: https://github.com/eddelbuettel/rcppsimdjson/blob/master/inst/examples/simpleParseBenchmark.R

Files from https://github.com/plokhotnyuk/jsoniter-scala/tree/master/jsoniter-scala-benchmark/src/main/resources/com/github/plokhotnyuk/jsoniter_scala/benchmark

See issue "Lower performance on small files":
https://github.com/lemire/simdjson/issues/70

library(RcppSimdJson)
if (RcppSimdJson:::.unsupportedArchitecture()) exit_file("Unsupported chipset")

my_temp_dir <- paste0(tempdir(), "/rcppsimdjson-compressed-temp")
if (!dir.exists(my_temp_dir)) dir.create(my_temp_dir)

.read_compress_write_load <- function(file_path) {
    types <- c("gzip", "bzip2", "xz")
    exts <- c("gz",    "bz2",   "xz")

    init <- readBin(file_path, n = file.size(file_path), what = "raw")

    mapply(function(type, ext) {
        target_path <- paste0(my_temp_dir, "/", basename(file_path), ".", ext)
        writeBin(memCompress(init, type = type), target_path)
        fload(target_path)
    }, types, exts, USE.NAMES = FALSE, SIMPLIFY = FALSE)
}

all_files <- dir(
    system.file("jsonexamples", package = "RcppSimdJson"),
    recursive = TRUE,
    pattern = "\\.json$",
    full.names = TRUE
)

sapply(all_files, function(.x) {
    expect_silent(.read_compress_write_load(.x))
})

unlink(my_temp_dir, recursive=TRUE, force=TRUE)

#!/usr/bin/env Rscript

stopifnot(need_microbenchmark=requireNamespace("microbenchmark",quietly=TRUE),
          need_jsonify=requireNamespace("jsonify",quietly=TRUE),
          need_jsonlite=requireNamespace("jsonlite",quietly=TRUE),
          need_RcppSimdJson=requireNamespace("RcppSimdJson",quietly=TRUE),
          need_ndjson=requireNamespace("ndjson", quietly=TRUE),
          need_RJSONIO=requireNamespace("RJSONIO", quietly=TRUE),
          need_ggplot2=requireNamespace("ggplot2", quietly=TRUE),
          need_yyjsonr=requireNamespace("yyjsonr", quietly=TRUE))

file <- system.file("jsonexamples", "twitter.json", package="RcppSimdJson")
json <- paste(readLines(file), collapse="")

res <- microbenchmark::microbenchmark(jsonify = jsonify::from_json(json),
                                      jsonlite = jsonlite::fromJSON(json),
                                      simdjson = RcppSimdJson::fparse(json),
                                      ndjson = ndjson::flatten(json),
                                      RJSONIO = RJSONIO::fromJSON(json),
                                      yyjsonr = yyjsonr::read_json_str(json),
                                      times = 100L)

res$expr <- with(res, reorder(expr, time, median))
print(res)
print(res, unit="relative")
p2 <- ggplot2::autoplot(res) +
    ggplot2::labs(title="Parsing JSON string", caption="See 'demo/simpeParseBenchmark.R' in package RcppSimdJson") +
    tinythemes::theme_ipsum_rc()

if (RcppSimdJson:::.unsupportedArchitecture()) exit_file("Unsupported chipset")

# .deserialize_json ============================================================
test <- c(
  first = '{"A":[[1,2,3],[4,5,6]]}',
  second = '{"B":[{"a":1,"b":true},{"a":2,"b":false,"c":null}]}'
)

target <- list(
  first = list(
    A = matrix(
      c(
        1L, 2L, 3L,
        4L, 5L, 6L
      ),
      nrow = 2L, ncol = 3L, byrow = TRUE
    )
  ),
  second = list(
    B = data.frame(
      a = c(1L, 2L),
      b = c(TRUE, FALSE),
      c = c(NA, NA)
    )
  )
)

expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)

# confirm errors work ----------------------------------------------------------
test <- c(
  first = '{"A":[[1,2,3],[4,5,6]]}',
  bad_json = '{"B":[{"a":1,"b":JUNK},{"a":2,"b":false,"c":null}]}'
)
expect_error(
  RcppSimdJson:::.deserialize_json(test)
)
# .load_json() =================================================================
test <- c(
  flatadversarial.json = "../jsonexamples/small/flatadversarial.json",
  adversarial.json = "../jsonexamples/small/adversarial.json"
)

if (!all(file.exists(test))) {
  exit_file(
    "flatadversarial.json and/or adversarial.json are missing."
  )
}

target <- list(
  flatadversarial.json = list(
    `"Name` = c("116", "\\\"", "234", "true", "FALSE"), t = 1e+10
  ),
  adversarial.json = list(
    `"Name rue` = structure(
      c("116", "\"", "234", "true", "FALSE"),
      .Dim = c(1L, 5L)
    )
  )
)

expect_identical(
  RcppSimdJson:::.load_json(test),
  target
)

# all files battery ------------------------------------------------------------
all_files <- dir("inst/jsonexamples", pattern = "\\.json$", 
                 recursive = TRUE, full.names = TRUE)
expect_silent(
  RcppSimdJson:::.load_json(all_files)
)
# confirm errors work ----------------------------------------------------------
expect_error(
  RcppSimdJson:::.load_json(c("a/fake/file.json", all_files))
)
expect_error(
  RcppSimdJson:::.load_json(c(all_files, "another/fake/file.json"))
)

if (RcppSimdJson:::.unsupportedArchitecture()) exit_file("Unsupported chipset")

# unicode_chr <- "լ ⿕  ٷ 豈 ٸ 㐀 ٹ 丂 Ɗ 一 á ٵ ̝ ѵ ̇ ˥ ɳ Ѡ · վ  й ף ޑ  ц Ґ  ӎ Љ ß ϧ ͎ ƽ ޜ է ϖ y Î վ Ο Ӊ ٻ ʡ ө ȭ ˅ ޠ ɧ ɻ ث ́ ܇ ܧ ɽ Ո 戸 Ð 坮 ٳ 䔢 찅 곂 묨 ß ᇂ ƻ 䏐 ܄ 㿕 ս ّ 昩 僫 똠 Ɯ ٰ É"
unicode_chr <- "\u056c \u2FD5  \u0677 \uf900 \u0678 \u3400 \u0679 \u4e02 \u018a \u4e00 \u00e1 \u0675 \u031d \u0475 \u0307 \u02e5 \u0273 \u0460 \u0387 \u057e  \u0439 \u05e3 \u0791  \u0446 \u0490  \u04ce \u0409 \u00df \u03e7 \u034e \u01bd \u079c \u0567 \u03d6 y \u00ce \u057e \u039f \u04c9 \u067b \u02a1 \u04e9 \u022d \u02c5 \u07a0 \u0267 \u027b \u062b \u0341 \u0707 \u0727 \u027d \u0548 \u6238 \u00d0 \u576e \u0673 \u4522 \ucc05 \uacc2 \ubb28 \u00df \u11c2 \u01bb \u43d0 \u0704 \u3fd5 \u057d \u0651 \u6629 \u50eb \ub620 \u019c \u0670 \u00c9"

# simple string
target <- unicode_chr
test <- sprintf('"%s"', unicode_chr)
expect_identical(fparse(test), target)
expect_identical(fparse(charToRaw(test)), target)
# object key and value
target <- `names<-`(list(unicode_chr), unicode_chr)
test <- sprintf('{"%s":"%s"}', unicode_chr, unicode_chr)
expect_identical(fparse(test), target)
expect_identical(fparse(charToRaw(test)), target)
# array
target <- c(unicode_chr, unicode_chr)
test <- sprintf('["%s","%s"]', unicode_chr, unicode_chr)
expect_identical(fparse(test), target)
expect_identical(fparse(charToRaw(test)), target)
# array (to matrix)
target <- matrix(unicode_chr, nrow = 2L, ncol = 2L)
test <- sprintf('[["%s","%s"],["%s","%s"]]',
                unicode_chr, unicode_chr, unicode_chr, unicode_chr)
expect_identical(fparse(test), target)
expect_identical(fparse(charToRaw(test)), target)
# object key and value
target <- `names<-`(list(unicode_chr), unicode_chr)
test <- sprintf('{"%s":"%s"}', unicode_chr, unicode_chr)
expect_identical(fparse(test), target)
expect_identical(fparse(charToRaw(test)), target)
# array of objects (to data frame)
target <- structure(list(c(unicode_chr, unicode_chr)),
                    class = "data.frame",
                    names = unicode_chr,
                    row.names = 1:2)
test <- sprintf('[{"%s":"%s"},{"%s":"%s"}]',
                unicode_chr, unicode_chr, unicode_chr, unicode_chr)
expect_identical(fparse(test), target)
expect_identical(fparse(charToRaw(test)), target)

if (RcppSimdJson:::.unsupportedArchitecture()) exit_file("Unsupported chipset")

my_temp_dir <- paste0(tempdir(), "/rcppsimdjson-temp")
if (!dir.exists(my_temp_dir)) dir.create(my_temp_dir)

# 33: prevent deletion of local files ==========================================
# https://github.com/eddelbuettel/rcppsimdjson/issues/33
temp_file1 <- tempfile(".json", tmpdir = my_temp_dir)
temp_file2 <- tempfile(".json", tmpdir = my_temp_dir)
writeLines('"json"', temp_file1)
writeLines('"json"', temp_file2)

fload(c(temp_file1, temp_file2), keep_temp_files = TRUE)
expect_true(all(file.exists(c(temp_file1, temp_file2))))
fload(c(temp_file1, temp_file2), keep_temp_files = FALSE)
expect_true(all(file.exists(c(temp_file1, temp_file2))))


# json_url <- "https://raw.githubusercontent.com/eddelbuettel/rcppsimdjson/master/inst/jsonexamples/small/demo.json"
json_url <- paste0("file:///", system.file("jsonexamples/small/demo.json", package = "RcppSimdJson"))

fload(json_url, temp_dir = my_temp_dir, keep_temp_files = TRUE)
expect_true(
    length(dir(my_temp_dir)) == 1L
)
unlink(dir(my_temp_dir, full.names = TRUE))
fload(json_url, temp_dir = my_temp_dir)
expect_true(
    length(dir(my_temp_dir)) == 0L
)

# 35: accept raw vectors =======================================================
# https://github.com/eddelbuettel/rcppsimdjson/issues/35
expect_identical(
    fparse(charToRaw('[true,false]')),
    c(TRUE, FALSE)
)
expect_identical(
    fparse(lapply(c('[true,false]', '[false,true]'), charToRaw)),
    list(c(TRUE, FALSE), c(FALSE, TRUE))
)
# ensure lists only work if all raw
expect_error(
    fparse(list('[true,false]', '[false,true]')),
)
expect_error(
    fparse(list('[true,false]', charToRaw('[false,true]')))
)

# 64: option to always return list (even for single-element vectors)  ==========
# https://github.com/eddelbuettel/rcppsimdjson/issues/64
#* fparse() --------------------------------------------------------------------
expect_error( # invalid `always_list` arg
    fparse('[false,true]', always_list = "not TRUE or FALSE")
)
expect_identical( # original behavior is unaffected
    fparse('[false,true]'),
    c(FALSE, TRUE)
)
expect_identical( # new, opt-in behavior
    fparse('[false,true]', always_list = TRUE),
    list(c(FALSE, TRUE))
)
expect_identical( # if `json=` is a named, single-element vector, keep the `names()`
    fparse(c(named_single_element_vector = '[false,true]'), always_list = TRUE),
    list(named_single_element_vector = c(FALSE, TRUE))
)
#* fload() ---------------------------------------------------------------------
expect_error( # invalid `always_list` arg
    fload(temp_file1, always_list = "not TRUE or FALSE")
)
expect_identical(
    fload(temp_file1),
    "json"
)
expect_identical(
    fload(temp_file1, always_list = TRUE),
    list("json")
)
expect_identical(
    fload(c(named_single_element_vector = temp_file1), always_list = TRUE),
    list(named_single_element_vector = "json")
)



# clean up temp files last =====================================================
unlink(my_temp_dir, recursive=TRUE, force=TRUE)

if (RcppSimdJson:::.unsupportedArchitecture()) exit_file("Unsupported chipset")

all_files <- dir("../jsonexamples", pattern = "\\.json$", 
                 recursive = TRUE, full.names = TRUE)

sapply(all_files, function(.x) expect_silent(RcppSimdJson:::.load_json(.x)))

expect_error(
  RcppSimdJson:::.load_json("../jsonexamples/amazon_cellphones.ndjson")
)

expect_error(
  RcppSimdJson:::.load_json("not/a/real/file.json")
)

if (RcppSimdJson:::.unsupportedArchitecture()) exit_file("Unsupported chipset")

# https://github.com/simdjson/simdjson/blob/master/tests/unicode_tests.cpp
valid_utf8 <- c(
    "a",
    "\xc3\xb1",
    "\xe2\x82\xa1",
    "\xf0\x90\x8c\xbc",
    "\xc2\x80",
    "\xf0\x90\x80\x80",
    "\xee\x80\x80",
    "\xef\xbb\xbf"
)
names(valid_utf8) <- paste0("valid_utf8_", seq_along(valid_utf8))

invalid_utf8 <- c(
    "\xc3\x28",
    "\xa0\xa1",
    "\xe2\x28\xa1",
    "\xe2\x82\x28",
    "\xf0\x28\x8c\xbc",
    "\xf0\x90\x28\xbc",
    "\xf0\x28\x8c\x28",
    "\xc0\x9f",
    "\xf5\xff\xff\xff",
    "\xed\xa0\x81",
    "\xf8\x90\x80\x80\x80",
    "123456789012345\xed",
    "123456789012345\xf1",
    "123456789012345\xc2",
    "\xC2\x7F",
    "\xce",
    "\xce\xba\xe1",
    "\xce\xba\xe1\xbd",
    "\xce\xba\xe1\xbd\xb9\xcf",
    "\xce\xba\xe1\xbd\xb9\xcf\x83\xce",
    "\xce\xba\xe1\xbd\xb9\xcf\x83\xce\xbc\xce",
    "\xdf",
    "\xef\xbf",
    "\x80",
    "\x91\x85\x95\x9e",
    "\x6c\x02\x8e\x18"
)
names(invalid_utf8) <- paste0("invalid_utf8_", seq_along(invalid_utf8))


expect_identical(
    `names<-`(rep(TRUE, length(valid_utf8)),  paste0("valid_utf8_", seq_along(valid_utf8))),
    is_valid_utf8(valid_utf8)
)
expect_identical(
    `names<-`(rep(FALSE, length(invalid_utf8)),  paste0("invalid_utf8_", seq_along(invalid_utf8))),
    is_valid_utf8(invalid_utf8)
)

expect_true(
    all(is_valid_utf8(valid_utf8)) &&
    all(vapply(valid_utf8, function(.x) is_valid_utf8(charToRaw(.x)), logical(1L))) &&
    all(is_valid_utf8(lapply(valid_utf8, charToRaw))) &&
    all(validUTF8(valid_utf8))
)

expect_false(
    any(is_valid_utf8(invalid_utf8)) ||
    any(vapply(invalid_utf8, function(.x) is_valid_utf8(charToRaw(.x)), logical(1L))) ||
    any(is_valid_utf8(lapply(invalid_utf8, charToRaw))) ||
    any(validUTF8(invalid_utf8))
)

expect_identical(is_valid_utf8(NA_character_), NA)
expect_error(is_valid_utf8(NULL))
expect_error(is_valid_utf8(1L))
expect_error(is_valid_utf8(3.14))
expect_error(is_valid_utf8(TRUE))
expect_error(is_valid_utf8(list(charToRaw('"VALID JSON"'), FALSE)))


prettified_json <- c(
'{
    "Image": {
        "Width":  800,
        "Height": 600,
        "Title":  "View from 15th Floor",
        "Thumbnail": {
            "Url":    "http://www.example.com/image/481989943",
            "Height": 125,
            "Width":  100
        },
        "Animated" : false,
        "IDs": [116, 943, 234, 38793]
    }
}',
'{
    "Width": 800,
    "Height": 600,
    "Title": "View from my room",
    "Url": "http://ex.com/img.png",
    "Private": false,
    "Thumbnail": {
        "Url": "http://ex.com/th.png",
        "Height": 125,
        "Width": 100
    },
    "array": [
        116,
        943,
        234
    ],
    "Owner": null
}',
"THIS IS JUNK!"
)
minified_json <- c(
'{"Image":{"Width":800,"Height":600,"Title":"View from 15th Floor","Thumbnail":{"Url":"http://www.example.com/image/481989943","Height":125,"Width":100},"Animated":false,"IDs":[116,943,234,38793]}}',
'{"Width":800,"Height":600,"Title":"View from my room","Url":"http://ex.com/img.png","Private":false,"Thumbnail":{"Url":"http://ex.com/th.png","Height":125,"Width":100},"array":[116,943,234],"Owner":null}',
NA_character_
)

expect_identical(
    fminify(prettified_json),
    minified_json
)
expect_identical(
    fminify(charToRaw(prettified_json[[1L]])),
    minified_json[[1L]]
)
expect_identical(
    fminify(charToRaw("junk")),
    NA_character_
)
expect_identical(
    fminify(charToRaw(prettified_json[[1L]])),
    minified_json[[1L]]
)
expect_identical(
    fminify(lapply(prettified_json, charToRaw)),
    minified_json
)
expect_error(fminify(NULL))
expect_error(fminify(1L))
expect_error(fminify(1.0))
expect_error(fminify(FALSE))
expect_identical(fminify(NA_character_), NA_character_)

expect_identical(fminify(NA_character_), NA_character_)
expect_error(fminify(NULL))
expect_error(fminify(1L))
expect_error(fminify(3.14))
expect_error(fminify(TRUE))
expect_error(fminify(list(charToRaw('\n"VALID JSON"'), FALSE)))


# is_valid_json ===============================================================
expect_true(all(is_valid_json(minified_json[!is.na(minified_json)])))
expect_true(is_valid_json(charToRaw(minified_json[[1L]])))
expect_true(
    all(
        is_valid_json(
            lapply(minified_json[!is.na(minified_json)], charToRaw)
        )
    )
)

expect_identical(is_valid_json(NA_character_), NA)
expect_error(is_valid_json(NULL))
expect_error(is_valid_json(1L))
expect_error(is_valid_json(1.0))
expect_error(is_valid_json(FALSE))
expect_error(is_valid_json(list(charToRaw('"VALID JSON"'), FALSE)))

expect_false(any(is_valid_json(valid_utf8)))
expect_false(any(is_valid_json(invalid_utf8)))

if (RcppSimdJson:::.unsupportedArchitecture()) exit_file("Unsupported chipset")

type_policy <- list(
  anything_goes = 0,
  ints_as_dbls = 1,
  strict = 2
)

int64_opt <- list(
  double = 0,
  string = 1,
  integer64 = 2,
  always = 3
)

simplify_lvl <- list(
  data_frame = 0,
  matrix = 1,
  vector = 2,
  list = 3
)

# scalar =======================================================================
#* integer ---------------------------------------------------------------------
test <- "1"
target <- 1L
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
if (requireNamespace("bit64", quietly = TRUE)) {
    target <- bit64::as.integer64(target)
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always),
        target
    )
}
#* double-----------------------------------------------------------------------
test <- "1.0"
target <- 1
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* logical ---------------------------------------------------------------------
test <- "true"
target <- TRUE
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* character -------------------------------------------------------------------
test <- '"string"'
target <- "string"
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* null ------------------------------------------------------------------------
test <- "null"
target <- NULL
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* i64 -------------------------------------------------------------------------
test <- "10000000000"
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$double),
  10000000000
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$string),
  test
)
if (requireNamespace("bit64", quietly = TRUE)) {
    expect_identical(
      RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64),
      bit64::as.integer64(test)
    )

    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always),
        bit64::as.integer64(test)
    )
}
#* u64 -------------------------------------------------------------------------
test <- "10000000000000000000"
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  test
)

# homogeneous array ============================================================
#* empty -----------------------------------------------------------------------
test <- "[]"
target <- logical()
expect_identical(
  RcppSimdJson:::.deserialize_json(test, empty_array = target),
  target
)
#* integer ---------------------------------------------------------------------
test <- "[1,2]"
target <- c(1L, 2L)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* integer - int64="always" ----------------------------------------------------
test <- "[1,2]"
target <- structure(c(4.94065645841247e-324, 9.88131291682493e-324), class = "integer64")
expect_identical(
    RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always),
    target
)
#* double ----------------------------------------------------------------------
test <- "[1.0,2.0]"
target <- c(1, 2)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* logical =====================================================================
test <- "[true,false]"
target <- c(TRUE, FALSE)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* character -------------------------------------------------------------------
test <- '["a","b"]'
target <- c("a", "b")
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* null ------------------------------------------------------------------------
test <- "[null,null]"
target <- c(NA, NA)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* i64 -------------------------------------------------------------------------
test <- "[10000000000,20000000000]"

target <- c(10000000000, 20000000000)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$double),
  target
)

target <- c("10000000000", "20000000000")
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$string),
  target
)

target <- structure(c(4.94065645841247e-314, 9.88131291682493e-314),
  class = "integer64"
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64),
  target
)
#* u64 -------------------------------------------------------------------------
test <- "[10000000000000000000,10000000000000000001]"
target <- c("10000000000000000000", "10000000000000000001")
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)

# homogeneous array w/ nulls ===================================================
#* integer ---------------------------------------------------------------------
#** null first
test <- "[null,1,2]"
target <- c(NA, 1L, 2L)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#*** integer - int64="always"
if (requireNamespace("bit64", quietly = TRUE)) {
    target <- bit64::as.integer64(target)
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always),
        target
    )
}

#** null last
test <- "[1,2,null]"
target <- c(1L, 2L, NA)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
if (requireNamespace("bit64", quietly = TRUE)) {
    target <- bit64::as.integer64(target)
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always),
        target
    )
}

#* double ----------------------------------------------------------------------
#** null first
test <- "[null,1.0,2.0]"
target <- c(NA, 1, 2)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#** null last
test <- "[1.0,2.0,null]"
target <- c(1, 2, NA)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* logical ---------------------------------------------------------------------
#** null first
test <- "[null,true,false]"
target <- c(NA, TRUE, FALSE)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#** null last
test <- "[true,false,null]"
target <- c(TRUE, FALSE, NA)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* character -------------------------------------------------------------------
#** null first
test <- '[null,"a","b"]'
target <- c(NA, "a", "b")
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#** null last
test <- '["a","b",null]'
target <- c("a", "b", NA)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* i64 -------------------------------------------------------------------------
#** null first
test <- "[null,10000000000,20000000000]"
target <- c(NA, 10000000000, 20000000000)

expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$double),
  target
)

if (requireNamespace("bit64", quietly = TRUE)) {
    target <- bit64::as.integer64(target)
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64),
        target
    )
}

target <- as.character(target)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$string),
  target
)



#** null last
test <- "[10000000000,20000000000,null]"
target <- c(10000000000, 20000000000, NA)

expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$double),
  target
)

if (requireNamespace("bit64", quietly = TRUE)) {
    target <- bit64::as.integer64(c(10000000000, 20000000000, NA))
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64),
        target
    )
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always),
        target
    )
}

target <- c("10000000000", "20000000000", NA)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$string),
  target
)




#* u64 -------------------------------------------------------------------------
#** null first
null_first <- "[null,10000000000000000000,10000000000000000001]"
expect_identical(
  RcppSimdJson:::.deserialize_json(null_first),
  c(NA, "10000000000000000000", "10000000000000000001")
)
# #** null last
null_last <- "[10000000000000000000,10000000000000000001,null]"
expect_identical(
  RcppSimdJson:::.deserialize_json(null_last),
  c("10000000000000000000", "10000000000000000001", NA)
)

# mixed arrays =================================================================
#* all types -------------------------------------------------------------------
test <- '[null,"a",true,1,1.0,10000000000,10000000000000000000]'

target <- c(NA, "a", "TRUE", "1", "1.0", "10000000000", "10000000000000000000")
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)

target <- list(NULL, "a", TRUE, 1L, 1, 1e+10, "10000000000000000000")
expect_identical(
  RcppSimdJson:::.deserialize_json(test, type_policy = type_policy$ints_as_dbls),
  target
)

target <- list(NULL, "a", TRUE, 1L, 1, 10000000000, "10000000000000000000")
expect_identical(
  RcppSimdJson:::.deserialize_json(test, type_policy = type_policy$strict),
  target
)
#* mixed integers --------------------------------------------------------------
test <- "[null,1,10000000000]"

target <- c(NA, 1, 10000000000)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)


target <- list(NULL, 1L, 10000000000)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, type_policy = type_policy$strict),
  target
)

if (requireNamespace("bit64", quietly = TRUE)) {
    target2 <- lapply(target, function(.x) if (is.double(.x)) bit64::as.integer64(.x) else .x)
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64,
                                         type_policy = type_policy$strict),
        target2
    )

    target2 <- bit64::as.integer64(
        unlist(lapply(target, function(.x) if (length(.x)) .x else NA))
    )
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always,
                                         type_policy = type_policy$strict),
        target2
    )
}

target <- c(NA, "1", "10000000000")
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$string),
  target
)

target <- list(NULL, 1L, "10000000000")
expect_identical(
  RcppSimdJson:::.deserialize_json(
    test,
    type_policy = type_policy$strict,
    int64_r_type = int64_opt$string
  ),
  target
)

#* logicals and integers -------------------------------------------------------
test <- "[null,1,true,false]"
target <- c(NA, 1L, TRUE, FALSE)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)

test <- "[true,false,1]"
target <- list(TRUE, FALSE, 1L)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, type_policy = type_policy$strict),
  target
)
#* logicals and integer64 ------------------------------------------------------
if (requireNamespace("bit64", quietly = TRUE)) {
    test <- "[null,10000000000,true,false]"
    target <- bit64::as.integer64(c(NA, 10000000000, TRUE, FALSE))

    expect_identical(
      RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64),
      target
    )
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always),
        target
    )

    test <- "[true,false,10000000000]"
    target <- list(TRUE, FALSE, bit64::as.integer64("10000000000"))

    expect_identical(
      RcppSimdJson:::.deserialize_json(test,
        type_policy = type_policy$strict,
        int64_r_type = int64_opt$integer64
      ),
      target
    )

    expect_identical(
        RcppSimdJson:::.deserialize_json(test,
                                         type_policy = type_policy$strict,
                                         int64_r_type = int64_opt$always),
        target
    )
}
#* logicals and doubles --------------------------------------------------------
test <- "[null,1.0,true,false]"
target <- c(NA, 1, TRUE, FALSE)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)

test <- "[true,false,1.0]"
target <- list(TRUE, FALSE, 1)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, type_policy = type_policy$strict),
  target
)
#* doubles and mixed integers --------------------------------------------------
test <- "[null,1,1.1,10000000000]"

target <- c(NA, 1, 1.1, 10000000000)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)


target <- c(NA, 1, 1.1, 10000000000)
expect_identical(
    RcppSimdJson:::.deserialize_json(test),
    target
)


target <- c(NA, 1L, 1.1, 10000000000)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, type_policy = type_policy$ints_as_dbls),
  target
)


target <- list(NULL, 1L, 1.1, "10000000000")
expect_identical(
  RcppSimdJson:::.deserialize_json(test,
                                   type_policy = type_policy$strict,
                                   int64_r_type = int64_opt$string),
  target
)



if (requireNamespace("bit64", quietly = TRUE)) {
    target <- lapply(target, function(.x) if (is.character(.x)) bit64::as.integer64(.x) else .x)
    expect_identical(
      RcppSimdJson:::.deserialize_json(test,
                                       type_policy = type_policy$strict,
                                       int64_r_type = int64_opt$integer64),
      target
    )

    target <- lapply(target, function(.x) if (is.integer(.x)) bit64::as.integer64(.x) else .x)
    expect_identical(
        RcppSimdJson:::.deserialize_json(test,
                                         type_policy = type_policy$strict,
                                         int64_r_type = int64_opt$always),
        target
    )
}


test <- '[null,"stuff",10000000000]'
target <- c(NA, "stuff", "10000000000")
expect_identical(
    RcppSimdJson:::.deserialize_json(test,
                                     # type_policy = type_policy$strict,
                                     int64_r_type = int64_opt$string),
    target
)

test <- '[null,1,10000000000]'
target <- c(NA, 1, 10000000000)
expect_identical(
    RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$double),
    target
)


#* logicals, doubles, and mixed integers ---------------------------------------
test <- "[null,true,false,1,1.1,10000000000]"

target <- c(NA, 1, 0, 1, 1.1, 10000000000)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)

target <- list(NULL, TRUE, FALSE, 1L, 1.1, 10000000000)
expect_identical(
  RcppSimdJson:::.deserialize_json(
    test,
    type_policy = type_policy$strict
  ),
  target
)

target <- list(NULL, TRUE, FALSE, 1L, 1.1, "10000000000")
expect_identical(
  RcppSimdJson:::.deserialize_json(
    test,
    type_policy = type_policy$strict,
    int64_r_type = int64_opt$string
  ),
  target
)

if (requireNamespace("bit64", quietly = TRUE)) {
    target <- lapply(target, function(.x) if (is.character(.x)) bit64::as.integer64(.x) else .x)
    expect_identical(
      RcppSimdJson:::.deserialize_json(test,
                                       type_policy = type_policy$strict,
                                       int64_r_type = int64_opt$integer64),
      target
    )

    target <- lapply(target, function(.x) if (is.integer(.x)) bit64::as.integer64(.x) else .x)
    expect_identical(
        RcppSimdJson:::.deserialize_json(test,
                                         type_policy = type_policy$strict,
                                         int64_r_type = int64_opt$always),
        target
    )
}

# homogeneous matrices =========================================================
#* empty -----------------------------------------------------------------------
test <- "[[],
          []]"
target <- structure(logical(0), .Dim = c(2L, 0L))
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* integer ---------------------------------------------------------------------
test <- "[[1,2],
          [3,4]]"
target <- matrix(
  c(
    1L, 2L,
    3L, 4L
  ),
  nrow = 2L, ncol = 2L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* double ----------------------------------------------------------------------
test <- "[[1.0,2.0],
          [3.0,4.0]]"
target <- matrix(
  c(
    1, 2,
    3, 4
  ),
  nrow = 2L, ncol = 2L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* logical =====================================================================
test <- "[[true,false],
          [false,true]]"
target <- matrix(
  c(
    TRUE, FALSE,
    FALSE, TRUE
  ),
  nrow = 2L, ncol = 2L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* character -------------------------------------------------------------------
test <- '[["a","b"],
          ["c","d"]]'
target <- matrix(
  c(
    "a", "b",
    "c", "d"
  ),
  nrow = 2L, ncol = 2L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* null ------------------------------------------------------------------------
test <- "[[null,null],
          [null,null]]"
target <- matrix(
  c(NA, NA, NA, NA),
  nrow = 2L, ncol = 2L
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* i64 -------------------------------------------------------------------------
test <- "[[10000000000,20000000000],
          [30000000000,40000000000]]"

target <- matrix(
  c(
    10000000000, 20000000000,
    30000000000, 40000000000
  ),
  nrow = 2L, ncol = 2L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$double),
  target
)

target <- matrix(
  c(
    "10000000000", "20000000000",
    "30000000000", "40000000000"
  ),
  nrow = 2L, ncol = 2L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$string),
  target
)

if (requireNamespace("bit64", quietly = TRUE)) {
    target <- structure(bit64::as.integer64(target), .Dim = dim(target))
    expect_identical(
      RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64),
      target
    )
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always),
        target
    )
}
#* u64 -------------------------------------------------------------------------
test <- "[[10000000000000000000,10000000000000000002],
          [10000000000000000003,10000000000000000004]]"
target <- matrix(
  c(
    "10000000000000000000", "10000000000000000002",
    "10000000000000000003", "10000000000000000004"
  ),
  nrow = 2L, ncol = 2L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)

# homogeneous matrices w/nulls =================================================
#* empty -----------------------------------------------------------------------
test <- "[[null,null],
          [null,null]]"
target <- matrix(c(NA, NA, NA, NA), nrow = 2L, ncol = 2L)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* integer ---------------------------------------------------------------------
test <- "[[null, 1, 2],
          [3,    4, null]]"
target <- matrix(
  c(
    NA, 1L, 2L,
    3L, 4L, NA
  ),
  nrow = 2L, ncol = 3L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* double ----------------------------------------------------------------------
test <- "[[null,1.0,2.0],
          [3.0,4.0,null]]"
target <- matrix(
  c(
    NA, 1, 2,
    3, 4, NA
  ),
  nrow = 2L, ncol = 3L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* logical =====================================================================
test <- "[[null,true,false],
          [false,true,null]]"
target <- matrix(
  c(
    NA, TRUE, FALSE,
    FALSE, TRUE, NA
  ),
  nrow = 2L, ncol = 3L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* character -------------------------------------------------------------------
test <- '[[null,"a","b"],
          ["c","d",null]]'
target <- matrix(
  c(
    NA, "a", "b",
    "c", "d", NA
  ),
  nrow = 2L, ncol = 3L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* i64 -------------------------------------------------------------------------
test <- "[[null,10000000000,20000000000],
          [30000000000,40000000000,null]]"

target <- matrix(
  c(
    NA, 10000000000, 20000000000,
    30000000000, 40000000000, NA
  ),
  nrow = 2L, ncol = 3L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$double),
  target
)

target <- matrix(
  c(
    NA, "10000000000", "20000000000",
    "30000000000", "40000000000", NA
  ),
  nrow = 2L, ncol = 3L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$string),
  target
)

if (requireNamespace("bit64", quietly = TRUE)) {
    target <- structure(bit64::as.integer64(target), .Dim = dim(target))
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64),
        target
    )
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always),
        target
    )
}
#* u64 -------------------------------------------------------------------------
test <- "[[null,10000000000000000000,10000000000000000002],
          [10000000000000000003,10000000000000000004,null]]"
target <- matrix(
  c(
    NA, "10000000000000000000", "10000000000000000002",
    "10000000000000000003", "10000000000000000004", NA
  ),
  nrow = 2L, ncol = 3L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)


# mixed matrices ===============================================================
#* all types -------------------------------------------------------------------
test <- '[[null,"a",true,1,1.0,10000000000,10000000000000000000],
          [10000000000000000000,10000000000,1.0,1,true,"a",null]]'


target <- matrix(
  c(
    NA, "a", "TRUE", "1", "1.0", "10000000000", "10000000000000000000",
    "10000000000000000000", "10000000000", "1.0", "1", "TRUE", "a", NA
  ),
  nrow = 2L, ncol = 7L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)

target <- list(
  list(NULL, "a", TRUE, 1L, 1, 1e+10, "10000000000000000000"),
  list("10000000000000000000", 1e+10, 1, 1L, TRUE, "a", NULL)
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, type_policy = type_policy$strict),
  target
)
#* mixed integers --------------------------------------------------------------
test <- "[[null,1,10000000000],
          [10000000000,1,null]]"

target <- matrix(
  c(
    NA, 1, 10000000000,
    10000000000, 1, NA
  ),
  nrow = 2L, ncol = 3L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)

target <- matrix(
  c(
    NA, "1", "10000000000",
    "10000000000", "1", NA
  ),
  nrow = 2L, ncol = 3L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$string),
  target
)

if (requireNamespace("bit64", quietly = TRUE)) {
    target <- structure(bit64::as.integer64(target), .Dim = dim(target))

    expect_identical(
      RcppSimdJson:::.deserialize_json(test,
                                       int64_r_type = int64_opt$integer64),
      target
    )

    expect_identical(
        RcppSimdJson:::.deserialize_json(test,
                                         int64_r_type = int64_opt$always),
        target
    )
}
#* logicals and integers -------------------------------------------------------
test <- "[[null,1,true,false],
          [false,true,1,null]]"
target <- matrix(
  c(
    NA, 1L, 1L, 0L,
    0L, 1L, 1L, NA
  ),
  nrow = 2L, ncol = 4L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* logicals and integer64 ------------------------------------------------------
test <- "[[null,10000000000,true,false],
          [false,true,10000000000,null]]"

target <- matrix(
  c(
    NA, "10000000000", "TRUE", "FALSE",
    "FALSE", "TRUE", "10000000000", NA
  ),
  nrow = 2L, ncol = 4L, byrow = TRUE
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$string),
  target
)

if (requireNamespace("bit64", quietly = TRUE)) {
    target <- structure(
        bit64::as.integer64(
            matrix(c(NA, 10000000000, TRUE, FALSE,
                     FALSE, TRUE, 10000000000, NA),
                   nrow = 2L, ncol = 4L, byrow = TRUE)
        ),
        .Dim = c(2L, 4L)
    )
    expect_identical(
      RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64),
      target
    )
}
# objects ======================================================================
#* empty object ----------------------------------------------------------------
test <- '{}'
target <- structure(list(), .Names = character(0))
expect_identical(
  RcppSimdJson:::.deserialize_json(test, empty_object = target),
  target
)
#* simple named lists ----------------------------------------------------------
test <- '{"a":[1.0,2.0]}'
target <- list(a = c(1, 2))
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* deeply nested lists ---------------------------------------------------------
test <-
  '{
    "a": [
        1,
        {
            "b": [
                2,
                {
                    "c": 3,
                    "d": {
                        "data_frame": [
                            {
                                "scalar_col": 4,
                                "matrix_col": [
                                    [
                                        5,
                                        6
                                    ],
                                    [
                                        7,
                                        8
                                    ]
                                ]
                            }
                        ]
                    }
                }
            ]
        }
    ]
}'
target <- list(
  a = list(
    1L, list(
      b = list(
        2L,
        list(
          c = 3L,
          d = list(
            data_frame = structure(
              list(
                scalar_col = 4L,
                matrix_col = list(
                  structure(
                    c(5L, 7L, 6L, 8L),
                    .Dim = c(2L, 2L)
                  )
                )
              ),
              row.names = 1L,
              class = "data.frame"
            )
          )
        )
      )
    )
  )
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)
#* simple data frames ----------------------------------------------------------
test <-
  '[
    {
        "these": 1,
        "names": null,
        "arent": true,
        "sorted": null,
        "i64": true,
        "u64": 10000000000000000000
    },
    {
        "these": null,
        "names": "b",
        "arent": null,
        "sorted": 1.5,
        "col_missing_from_first_row": "face",
        "i64": 3000000000,
        "u64": 10000000000000000001
    }
]'

target <- data.frame(
  these = c(1L, NA),
  names = c(NA, "b"),
  arent = c(TRUE, NA),
  sorted = c(NA, 1.5),
  i64 = c(1, 3000000000),
  u64 = c("10000000000000000000", "10000000000000000001"),
  col_missing_from_first_row = c(NA, "face"),
  stringsAsFactors = FALSE
)

expect_identical(
  RcppSimdJson:::.deserialize_json(test),
  target
)

if (requireNamespace("bit64", quietly = TRUE)) {
    target$i64 <- bit64::as.integer64(target$i64)
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64),
        target
    )
    target$these <- bit64::as.integer64(target$these)
    expect_identical(
        RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$always),
        target
    )
}
#* nested data frames ----------------------------------------------------------
test <-
  '[
    {
        "bool": true,
        "chr": "a",
        "dbl": 1.1,
        "int": 1,
        "int64": 10000000000,
        "list": [
            1,
            2
        ],
        "nested_dfs": [
            {
                "a": 1.1,
                "b": true,
                "c": "a"
            }
        ]
    },
    {
        "bool": false,
        "chr": "b",
        "dbl": 2.2,
        "int": 2,
        "int64": 20000000000,
        "list": [
            "a",
            "b"
        ],
        "nested_dfs": [
            {
                "a": 2.2,
                "b": false,
                "c": "b"
            }
        ]
    },
    {
        "bool": null,
        "chr": null,
        "dbl": null,
        "int": null,
        "int64": null,
        "list": [
            null,
            null
        ],
        "nested_dfs": [
            {
                "a": null,
                "b": null,
                "c": null
            }
        ]
    }
]'

target <- list(
  bool = c(TRUE, FALSE, NA),
  chr = c("a", "b", NA),
  dbl = c(1.1, 2.2, NA),
  int = c(1L, 2L, NA),
  int64 = structure(
    c(4.94065645841247e-314, 9.88131291682493e-314, 0),
    class = "integer64"
  ),
  list = list(c(1L, 2L), c("a", "b"), c(NA, NA)),
  nested_dfs = list(
    data.frame(a = 1.1, b = TRUE, c = "a"),
    data.frame(a = 2.2, b = FALSE, c = "b"),
    data.frame(a = NA, b = NA, c = NA)
  )
)
class(target) <- "data.frame"
rownames(target) <- 1:3

expect_identical(
  RcppSimdJson:::.deserialize_json(test, int64_r_type = int64_opt$integer64),
  target
)
# other simplify levels ========================================================
test <- '[{"a":[1,2],"g":[[3,4],[5,6]]}]'
#* matrix ----------------------------------------------------------------------
target <- list(
  list(
    a = 1:2,
    g = matrix(
      c(3L, 5L, 4L, 6L),
      nrow = 2L, ncol = 2L
    )
  )
)
expect_identical(
  RcppSimdJson:::.deserialize_json(test, simplify_to = simplify_lvl$matrix),
  target
)
expect_identical(
  RcppSimdJson:::.deserialize_json(
    test,
    type_policy = type_policy$ints_as_dbls,
    simplify_to = simplify_lvl$matrix
  ),
  target
)
expect_identical(
  RcppSimdJson:::.deserialize_json(
    test,
    type_policy = type_policy$strict,
    simplify_to = simplify_lvl$matrix
  ),
  target
)
#* vector ----------------------------------------------------------------------
target <- list(list(a = 1:2, g = list(3:4, 5:6)))
expect_identical(
  RcppSimdJson:::.deserialize_json(test, simplify_to = simplify_lvl$vector),
  target
)
expect_identical(
  RcppSimdJson:::.deserialize_json(
    test,
    type_policy = type_policy$ints_as_dbls,
    simplify_to = simplify_lvl$vector
  ),
  target
)
expect_identical(
  RcppSimdJson:::.deserialize_json(
    test,
    type_policy = type_policy$strict,
    simplify_to = simplify_lvl$vector
  ),
  target
)
#* list ------------------------------------------------------------------------
target <- list(list(a = list(1L, 2L), g = list(list(3L, 4L), list(5L, 6L))))
expect_identical(
  RcppSimdJson:::.deserialize_json(test, simplify_to = simplify_lvl$list),
  target
)
expect_identical(
  RcppSimdJson:::.deserialize_json(
    test,
    type_policy = type_policy$ints_as_dbls,
    simplify_to = simplify_lvl$list
  ),
  target
)
expect_identical(
  RcppSimdJson:::.deserialize_json(
    test,
    type_policy = type_policy$strict,
    simplify_to = simplify_lvl$list
  ),
  target
)

if (RcppSimdJson:::.unsupportedArchitecture()) exit_file("Unsupported chipset")
library(RcppSimdJson)

.read_file <- function(file_path) {
    readChar(file_path, nchars = file.size(file_path))
}
.write_file <- function(x, file_path) {
    writeChar(x, file_path, nchars = nchar(x), eos = NULL)
}

test_file1 <- tempfile(fileext = ".json")
test_file2 <- tempfile(fileext = ".json")

# json =========================================================================
#* invalid ---------------------------------------------------------------------
#** fparse() -------------------------------------------------------------------
expect_error(fparse(1))
expect_error(fparse(integer(0L)))
expect_error(fparse(NULL))
expect_error(fparse(NA_integer_))

expect_error(fparse("1", parse_error_ok = NA))
#** fload() --------------------------------------------------------------------
expect_error(fload(1))
expect_error(fload(NA_integer_))

expect_error(fload("1", parse_error_ok = NA))

.write_file("junk JSON", test_file1)
.write_file("more junk JSON", test_file2)
expect_error(fparse(test_file1))
expect_error(fload(c(test_file1, test_file2)))

#* valid -----------------------------------------------------------------------
#** fparse() -------------------------------------------------------------------
expect_identical(fparse(NA_character_), NA)
expect_identical(fparse("1"),
                 1L)
expect_identical(fparse(c("1", "2")),
                 list(1L, 2L))
expect_identical(fparse(c(json1 = "1", json2 = "2")),
                 list(json1 = 1L, json2 = 2L))
expect_identical(fparse(NA_character_),
                 NA)
expect_identical(fparse(c(NA_character_, NA_character_)),
                 list(NA, NA))
expect_identical(fparse(c("1", NA_character_)),
                 list(1L, NA))
expect_true(fparse("null", single_null = TRUE))
expect_true(fparse("junk JSON", parse_error_ok = TRUE, on_parse_error = TRUE))
expect_identical(fparse(c("junk JSON", "more junk JSON"),
                        parse_error_ok = TRUE, on_parse_error = NA),
                 list(NA, NA))

#** fload() --------------------------------------------------------------------
expect_identical(fload(NA_character_), NA)

.write_file("1", test_file1)
.write_file("2", test_file2)

expect_identical(fload(test_file1), 1L)
expect_identical(
    fload(c(test_file1, test_file2)),
    `names<-`(list(1L, 2L), basename(c(test_file1, test_file2)))
)

expect_identical(fload(c(json1 = test_file1, json2 = test_file2)),
                 list(json1 = 1L, json2 = 2L))
expect_identical(fload(NA_character_),
                 NA)
expect_identical(fload(c(NA_character_, NA_character_)),
                 list(NA, NA))
expect_identical(fload(c(test_file1, NA_character_))[[2L]], NA)

.write_file("null", test_file1)
expect_true(fload(test_file1, single_null = TRUE))

.write_file("junk JSON", test_file1)
.write_file("more junk JSON", test_file2)

expect_true(fload(test_file1, parse_error_ok = TRUE, on_parse_error = TRUE))
expect_identical(
    fload(c(test_file1, test_file2),
          parse_error_ok = TRUE, on_parse_error = NA),
    `names<-`(list(NA, NA), basename(c(c(test_file1, test_file2))))
)
# _ ============================================================================
# query ========================================================================
#* invalid ---------------------------------------------------------------------
#*** fparse() ------------------------------------------------------------------
expect_error(identical(fparse("1", query = c("0", "0")), list(1L, 1L)))
expect_error(fparse("1", query = (not_chr <- TRUE)))
#*** fload() -------------------------------------------------------------------
expect_error(fload("1", query = c("0", "0")))
expect_error(fload("1", query = (not_chr <- TRUE)))

#* valid -----------------------------------------------------------------------
#*** fparse() ------------------------------------------------------------------
expect_identical(fparse("1", query = NA_character_), NA)
expect_identical(fparse("[0,1]", query = "/0"),
                 0L)
expect_identical(fparse("1", query = NULL),
                 1L)
#*** fload() -------------------------------------------------------------------
.write_file("[0,1]", test_file1)
expect_identical(fload(test_file1, query = NA_character_), NA)
expect_identical(fload(test_file1, query = "/0"),
                 0L)
.write_file("1", test_file1)
expect_identical(fload(test_file1, query = NULL),
                 1L)

# _ ============================================================================
# max_simplify_lvl =============================================================
#* invalid ---------------------------------------------------------------------
#*** fparse() ------------------------------------------------------------------
expect_error(fparse("1", max_simplify_lvl = ".invalid"))
expect_error(fparse("1", max_simplify_lvl = NA_character_))
expect_error(fparse("1", max_simplify_lvl = 10))
expect_error(fparse("1", max_simplify_lvl = (not_chr_or_num <-
                                                 TRUE)))
#*** fload() -------------------------------------------------------------------
expect_error(fload("1", max_simplify_lvl = ".invalid"))
expect_error(fload("1", max_simplify_lvl = NA_character_))
expect_error(fload("1", max_simplify_lvl = 10))
expect_error(fload("1", max_simplify_lvl = (not_chr_or_num <-
                                                TRUE)))
#* valid -----------------------------------------------------------------------
test <- '[
    {"a":1},
    {"a":[1,2]},
    {"a":[[1,2],
    [3,4]]}
]'
.write_file(test, test_file1)

#** max_simplify_lvl = "data_frame" --------------------------------------------
target <- structure(
    list(a = list(
        1L, 1:2,
        matrix(c(1L, 2L, 3L, 4L), nrow = 2L, ncol = 2L, byrow = TRUE)
        )
    ),class = "data.frame",
    row.names = c(NA, 3L)
)
#*** fparse() ------------------------------------------------------------------
expect_identical(fparse(test, max_simplify_lvl = "data_frame"), target)
expect_identical(fparse(test, max_simplify_lvl = 0L), target)
#*** fload() -------------------------------------------------------------------
expect_identical(fload(test_file1, max_simplify_lvl = "data_frame"), target)
expect_identical(fload(test_file1, max_simplify_lvl = 0L), target)

#** max_simplify_lvl = "matrix" ------------------------------------------------
target <- list(list(a = 1L),
               list(a = 1:2),
               list(a = matrix(
                   c(1L, 2L, 3L, 4L),
                   nrow = 2L,
                   ncol = 2L,
                   byrow = TRUE
               )))
#*** fparse() ------------------------------------------------------------------
expect_identical(fparse(test, max_simplify_lvl = "matrix"), target)
expect_identical(fparse(test, max_simplify_lvl = 1L), target)
#*** fload() -------------------------------------------------------------------
expect_identical(fload(test_file1, max_simplify_lvl = "matrix"), target)
expect_identical(fload(test_file1, max_simplify_lvl = 1L), target)

#** max_simplify_lvl = "vector" ------------------------------------------------
target <- list(list(a = 1L),
               list(a = 1:2),
               list(a = list(1:2, 3:4)))
#*** fparse() ------------------------------------------------------------------
expect_identical(fparse(test, max_simplify_lvl = "vector"),
                 target)
expect_identical(fparse(test, max_simplify_lvl = 2L),
                 target)
#*** fload() -------------------------------------------------------------------
expect_identical(fload(test_file1, max_simplify_lvl = "vector"),
                 target)
expect_identical(fload(test_file1, max_simplify_lvl = 2L),
                 target)

#** max_simplify_lvl = "list" --------------------------------------------------
target <- list(list(a = 1L),
               list(a = list(1L, 2L)),
               list(a = list(list(1L, 2L), list(3L, 4L))))
#*** fparse() ------------------------------------------------------------------
expect_identical(fparse(test, max_simplify_lvl = "list"),
                 target)

expect_identical(fparse(test, max_simplify_lvl = 3L),
                 target)
#*** fload() -------------------------------------------------------------------
expect_identical(fparse(test, max_simplify_lvl = "list"),
                 target)

expect_identical(fparse(test, max_simplify_lvl = 3L),
                 target)

expect_identical(fparse("[[null, null],[null,null]]"),
                 matrix(NA, nrow = 2L, ncol = 2L))
expect_identical(fparse("[[true,false],[true,false]]"),
                 matrix(c(TRUE, TRUE, FALSE, FALSE),
                        nrow = 2L, ncol = 2L))
expect_identical(
    fparse(
        "[[9999999999999999999,9999999999999999999],[9999999999999999999,9999999999999999999]]"
    ),
    matrix(
        rep("9999999999999999999", 4L),
        nrow = 2L,
        ncol = 2L
    )
)
expect_identical(fparse("[[9999999999999999999,1],[1,1]]"),
                 matrix(
                     c("9999999999999999999", "1", "1", "1"),
                     nrow = 2L,
                     ncol = 2L
                 ))

# _ ============================================================================
# type_policy ==================================================================
#* invalid ---------------------------------------------------------------------
#*** fparse() ------------------------------------------------------------------
expect_error(fparse("1", type_policy = ".invalid"))
expect_error(fparse("1", type_policy = NA_character_))
expect_error(fparse("1", type_policy = 10L))
expect_error(fparse("1", type_policy = NA_integer_))
expect_error(fparse("1", type_policy = (not_chr_or_num <- TRUE)))
#*** fload() -------------------------------------------------------------------
expect_error(fload("1", type_policy = ".invalid"))
expect_error(fload("1", type_policy = NA_character_))
expect_error(fload("1", type_policy = 10L))
expect_error(fload("1", type_policy = NA_integer_))
expect_error(fload("1", type_policy = (not_chr_or_num <- TRUE)))

#* valid -----------------------------------------------------------------------
test <- '[
[[null,"a"],
["b",  1]]
,
[[2,          3.14, true],
[3000000000, 3,    6.62607004]]
,
[[4,          5, 6.0221409],
[3000000000, 6, null]]
,
[[7,          8,  9 ],
[3000000000, 10, 11]]
]'
.write_file(test, test_file1)

#** type_policy = "anything_goes" ----------------------------------------------
target <- list(
    matrix(
        c(NA, "a", "b", "1"),
        nrow = 2L,
        ncol = 2L,
        byrow = TRUE
    ),
    matrix(
        c(2L, 3.14, TRUE, 3000000000, 3L, 6.62607004),
        nrow = 2L,
        ncol = 3L,
        byrow = TRUE
    ),
    matrix(
        c(4L, 5L, 6.0221409, 3000000000, 6L, NA),
        nrow = 2L,
        ncol = 3L,
        byrow = TRUE
    ),
    matrix(
        c(7L, 8L, 9L, 3000000000, 10L, 11L),
        nrow = 2L,
        ncol = 3L,
        byrow = TRUE
    )
)
#*** fparse() ------------------------------------------------------------------
expect_identical(fparse(test, type_policy = "anything_goes"),
                 target)
expect_identical(fparse(test, type_policy = 0L),
                 target)

expect_identical(fparse("[1,2]", type_policy = "anything_goes"),
                 c(1L, 2L))
expect_identical(fparse("[true,false]", type_policy = "anything_goes"),
                 c(TRUE, FALSE))
expect_identical(
    fparse("[9999999999999999999,9999999999999999999]",
           type_policy = "anything_goes"),
    c("9999999999999999999", "9999999999999999999")
)
expect_identical(fparse(
    "[null,null]",
    single_null = NA,
    type_policy = "anything_goes"
),
c(NA, NA))
#*** fload() -------------------------------------------------------------------
expect_identical(fload(test_file1, type_policy = "anything_goes"),
                 target)
expect_identical(fload(test_file1, type_policy = 0L),
                 target)

#** type_policy = "numbers" ----------------------------------------------------
target <- list(
    list(c(NA, "a"), list("b", 1L)),
    list(list(2L, 3.14, TRUE), c(3000000000, 3, 6.62607004)),
    matrix(
        c(4L, 5L, 6.0221409, 3000000000, 6L, NA),
        nrow = 2L,
        ncol = 3L,
        byrow = TRUE
    ),
    matrix(
        c(7L, 8L, 9L, 3000000000, 10L, 11L),
        nrow = 2L,
        ncol = 3L,
        byrow = TRUE
    )
)
#*** fparse() ------------------------------------------------------------------
expect_identical(fparse(test, type_policy = "numbers"),
                 target)
expect_identical(fparse(test, type_policy = 1L),
                 target)

expect_identical(fparse("[1,2]", type_policy = "numbers"),
                 c(1L, 2L))
expect_identical(fparse("[true,false]", type_policy = "numbers"),
                 c(TRUE, FALSE))
expect_identical(
    fparse("[9999999999999999999,9999999999999999999]", type_policy = "numbers"),
    c("9999999999999999999", "9999999999999999999")
)
expect_identical(fparse(
    "[null,null]",
    single_null = NA,
    type_policy = "numbers"
),
list(NA, NA))
#*** fload() -------------------------------------------------------------------
expect_identical(fload(test_file1, type_policy = "numbers"),
                 target)
expect_identical(fload(test_file1, type_policy = 1L),
                 target)

#** type_policy = "strict" -----------------------------------------------------
target <- list(list(c(NA, "a"), list("b", 1L)),
               list(list(2L, 3.14, TRUE), list(3000000000, 3L, 6.62607004)),
               list(list(4L, 5L, 6.0221409), list(3000000000, 6L, NULL)),
               list(c(7L, 8L, 9L), list(3000000000, 10L, 11L)))
#*** fparse() ------------------------------------------------------------------
expect_identical(fparse(test, type_policy = "strict"),
                 target)
expect_identical(fparse(test, type_policy = 2L),
                 target)

expect_identical(fparse("[1,2]", type_policy = "strict"),
                 c(1L, 2L))
expect_identical(fparse("[true,false]", type_policy = "strict"),
                 c(TRUE, FALSE))
expect_identical(
    fparse("[9999999999999999999,9999999999999999999]", type_policy = "strict"),
    c("9999999999999999999", "9999999999999999999")
)
expect_identical(fparse(
    "[null,null]",
    single_null = NA,
    type_policy = "strict"
),
list(NA, NA))
#*** fload() ------------------------------------------------------------------
expect_identical(fload(test_file1, type_policy = "strict"),
                 target)
expect_identical(fload(test_file1, type_policy = 2L),
                 target)

# _ ============================================================================
# int64_policy =================================================================
#* invalid ---------------------------------------------------------------------
#*** fparse() ------------------------------------------------------------------
expect_error(fparse("1", int64_policy = ".invalid"))
expect_error(fparse("1", int64_policy = NA_character_))
expect_error(fparse("1", int64_policy = 10))
expect_error(fparse("1", int64_policy = NA_integer_))
expect_error(fparse("1", int64_policy = (not_chr_or_num <- TRUE)))
#*** fload() -------------------------------------------------------------------
expect_error(fload("1", int64_policy = ".invalid"))
expect_error(fload("1", int64_policy = NA_character_))
expect_error(fload("1", int64_policy = 10))
expect_error(fload("1", int64_policy = NA_integer_))
expect_error(fload("1", int64_policy = (not_chr_or_num <- TRUE)))

#* valid -----------------------------------------------------------------------
test <- "[
[false,          8,  null],
[3000000000, 10, true]
]
"
.write_file(test, test_file1)

#** int64_policy = "double" ----------------------------------------------------
target <- matrix(
    c(0, 8, NA, 3000000000, 10, 1),
    nrow = 2L,
    ncol = 3L,
    byrow = TRUE
)
#*** fload() -------------------------------------------------------------------
expect_identical(fparse(test, int64_policy = "double"),
                 target)
expect_identical(fparse(test, int64_policy = 0L),
                 target)
#*** fload() -------------------------------------------------------------------
expect_identical(fload(test_file1, int64_policy = "double"),
                 target)
expect_identical(fload(test_file1, int64_policy = 0L),
                 target)

#** int64_policy = "string" ----------------------------------------------------
target <- matrix(
    c("FALSE", "8", NA, "3000000000", "10", "TRUE"),
    nrow = 2L,
    ncol = 3L,
    byrow = TRUE
)
#*** fparse() ------------------------------------------------------------------
expect_identical(fparse(test, int64_policy = "string"),
                 target)
expect_identical(fparse(test, int64_policy = 1L),
                 target)
#*** fload() -------------------------------------------------------------------
expect_identical(fload(test_file1, int64_policy = "string"),
                 target)
expect_identical(fload(test_file1, int64_policy = 1L),
                 target)

#** int64_policy = "integer64" -------------------------------------------------
if (requireNamespace("bit64", quietly = TRUE)) {
    target <-
        structure(bit64::as.integer64(c(0, 3000000000, 8, 10, NA, 1)),
                  .Dim = 2:3)
    #*** fparse() ------------------------------------------------------------------
    expect_identical(fparse(test, int64_policy = "integer64"),
                     target)
    expect_identical(fparse(test, int64_policy = 2L),
                     target)
    #*** fload() -------------------------------------------------------------------
    expect_identical(fload(test_file1, int64_policy = "integer64"),
                     target)
    expect_identical(fload(test_file1, int64_policy = 2L),
                     target)
}
#** int64_policy = "always" -------------------------------------------------
if (requireNamespace("bit64", quietly = TRUE)) {
    target <- structure(bit64::as.integer64(c(0, 3000000000, 8, 10, NA, 1)), .Dim = 2:3)
    #*** fparse() ------------------------------------------------------------------
    expect_identical(fparse(test, int64_policy = "always"),
                     target)
    expect_identical(fparse(test, int64_policy = 3L),
                     target)
    #*** fload() -------------------------------------------------------------------
    expect_identical(fload(test_file1, int64_policy = "always"),
                     target)
    expect_identical(fload(test_file1, int64_policy = 3L),
                     target)
}

#** int64_policy = "string" -------------------------------------------------
expect_identical(fparse("[3000000000, 1]"), c(3000000000, 1))
expect_identical(fparse("[3000000000, 1]", int64_policy = "string"),
                 c("3000000000", "1"))
expect_identical(fparse("[9999999999999999999, 1]"),
                 c("9999999999999999999", "1"))



# _ ============================================================================
# battery ======================================================================
#* vanilla JSON ----------------------------------------------------------------
all_files <- list.files(system.file("jsonexamples", package = "RcppSimdJson"),
                        recursive = TRUE,
                        pattern = "\\.json$",
                        full.names = TRUE)

#*** fparse() ------------------------------------------------------------------
for (i in seq_along(all_files)) {
    expect_silent(
        fparse(json = c(na1 = NA_character_,
                        file = .read_file(all_files[[i]]),
                        na2 = NA_character_))
    )
}



#*** fload() -------------------------------------------------------------------
.write_file("JUNK JSON", test_file1)
.write_file('"VALID JSON"', test_file2)

opts <- expand.grid(type_policy = c("anything_goes", "numbers", "strict"),
                    int64_policy = c("double", "string", "integer64", "always"),
                    max_simplify_lvl = c("data_frame", "matrix", "vector", "list"),
                    parse_error_ok = c(TRUE, FALSE),
                    query_error_ok = c(TRUE, FALSE),
                    file = c(utils::head(all_files), test_file1),
                    stringsAsFactors = FALSE)
opts <- opts[
    opts$file != test_file1 | (opts$file == test_file1 & opts$parse_error_ok),
]


for (i in seq_len(nrow(opts))) {
    if (i %% 2 == 0) {
        json_arg <- c(opts$file[[i]], test_file2)
        if (opts$parse_error_ok[[i]]) {
            json_arg <- c(test_file1, json_arg)
        }
        junk_query <- rep("junk", length(json_arg))
    } else {
        json_arg <- opts$file[[i]]
        junk_query <- list("junk")
    }

    if (!opts$query_error_ok[[i]]) {
        query_arg <- NULL
    } else {
        query_arg <- junk_query
    }

    expect_silent(
        fload(json = json_arg,
              query = query_arg,
              type_policy = opts$type_policy[[i]],
              int64_policy = opts$int64_policy[[i]],
              max_simplify_lvl = opts$max_simplify_lvl[[i]],
              parse_error_ok = opts$parse_error_ok[[i]],
              query_error_ok = opts$query_error_ok[[i]])
    )

    if (length(json_arg) == 1L) {
        json_arg <- readBin(opts$file[[i]], what = "raw",
                            n = file.size(json_arg))
    } else {
        json_arg <- lapply(
            json_arg,
            function(.x) readBin(.x, what = "raw", n = file.size(.x))
        )
    }
    if (is.raw(json_arg)) {
        query_arg <- query_arg[[1L]]
    }

    expect_silent(
        fparse(json = json_arg,
               query = query_arg,
               type_policy = opts$type_policy[[i]],
               int64_policy = opts$int64_policy[[i]],
               max_simplify_lvl = opts$max_simplify_lvl[[i]],
               parse_error_ok = opts$parse_error_ok[[i]],
               query_error_ok = opts$query_error_ok[[i]])
    )
}

#* NDJSON ----------------------------------------------------------------------
all_files <- dir(
    system.file("jsonexamples", package = "RcppSimdJson"),
    recursive = TRUE,
    pattern = "\\.ndjson$",
    full.names = TRUE
)
#*** fparse() ------------------------------------------------------------------
sapply(all_files, function(.x) {
    expect_error(fparse(.read_file(.x)))
})
#*** fload() -------------------------------------------------------------------
sapply(all_files, function(.x) expect_error(fload(.x)))



# fload()-specific -------------------------------------------------------------
expect_error(fload("not-a-real-file.rcppsimdjson"))

expect_error(fload("not a real file"))

expect_error(
    fload("not-a-real-file.rcppsimdjson",
          temp_dir = "not/a/real/directory"),
    "'temp_dir=' does not exist."
)

expect_error(
    fload("not-a-real-file.rcppsimdjson",
          keep_temp_files = NA),
    "'keep_temp_files=' must be either 'TRUE' or 'FALSE'"
)

expect_error(
    fload("not-a-real-file.rcppsimdjson",
          verbose = NA),
    "'verbose=' must be either 'TRUE' or 'FALSE'"
)

.write_file('{"valid JSON":true}', test_file1)
.write_file('{"valid JSON": true}', test_file2)

expect_identical(
    fload(c(test_file1, test_file2), query = "/valid JSON"),
    `names<-`(list(TRUE, TRUE), basename(c(test_file1, test_file2)))
)

expect_error(
    fload(test_file1, query = list("bad 1", "bad 2"))
)
expect_error(
    fload(test_file1, query_error_ok = NA)
)
expect_error(
    fload(test_file1, compressed_download = NA)
)



# TODO verify CRAN policies for downloading, Travis usage
if (FALSE) {
    expect_error(suppressWarnings(fload("https://not-a-real-url")))
    expect_error(suppressWarnings(fload("https://invalid https")))
    expect_error(suppressWarnings(fload("http://invalid http")))
    expect_error(suppressWarnings(fload("ftps://invalid ftps")))
    expect_error(suppressWarnings(fload("ftp://invalid ftp")))
    expect_error(suppressWarnings(fload("file://invalid file")))

    single_url <-
        "https://raw.githubusercontent.com/eddelbuettel/rcppsimdjson/master/inst/jsonexamples/small/demo.json"
    expect_silent(fload(single_url))

    multiple_urls <- c(
        single_url,
        "https://raw.githubusercontent.com/eddelbuettel/rcppsimdjson/master/inst/jsonexamples/small/smalldemo.json"
    )
    expect_identical(names(fload(multiple_urls)),
                     basename(multiple_urls))
    .write_file("true", test_file1)
    .write_file("false", test_file2)
    expect_silent(fload(
        c(test_file1, test_file2, multiple_urls),
        keep_temp_files = TRUE
    ))
    expect_identical(names(fload(multiple_urls)),
                     basename(multiple_urls))
}

if (RcppSimdJson:::.unsupportedArchitecture()) exit_file("Unsupported chipset")
library(RcppSimdJson)

# parse errors =================================================================
expect_error(fparse("junk", query = ""))
expect_error(fparse("junk", query = c("", "")))
expect_error(fparse(c("junk", "junk"), query = list("", "")))
expect_identical(
    fparse("junk", query = "", parse_error_ok = TRUE),
    NULL
)
expect_identical(
    fparse("junk", query = c("", ""), parse_error_ok = TRUE),
    NULL
)
expect_identical(
    fparse(c("junk", "junk"), query = list("", ""), parse_error_ok = TRUE),
    list(NULL, NULL)
)
expect_identical(
    fparse(c("junk", "junk"), query = list("", ""), parse_error_ok = TRUE,
           on_parse_error = NA),
    list(NA, NA)
)

# query errors =================================================================
expect_error(fparse("null", query = TRUE))
expect_error(fparse("null", query = character(0L)))
expect_error(fparse("null", query_error_ok = NA))
expect_error(fparse("null", query = "junk"))
expect_error(fparse("null", query = c("junk", "junk")))
expect_error(fparse(c("null", "null"), query = list("junk", "junk")))
expect_error(fparse("null", query = list("junk", "junk")))
expect_error(fparse(c("null", "null"), query = list(TRUE, FALSE)))


expect_identical(fparse("null", query = "junk", query_error_ok = TRUE), NULL)
expect_identical(
    fparse("null", query = "junk", query_error_ok = TRUE),
    NULL
)
expect_identical(
    fparse(c("null", "null"),
           query = list(c("junk", "junk"), c("junk", "junk")),
           query_error_ok = TRUE),
    list(list(NULL, NULL), list(NULL, NULL))
)
expect_identical(
    fparse(c("null", "null"),
           query = list(c("junk", "junk"), c("junk", "junk")),
           query_error_ok = TRUE,
           on_query_error = NA),
    list(list(NA, NA), list(NA, NA))
)

# single json ==================================================================
js <- c(single_json = '[{"a":[[1,2],[3,4]]},{"b":[[5,6],[7,8]]}]')
expect_identical(
    fparse(js),
    fparse(js, query = "")
)
expect_identical(
    fparse(js, NA_character_),
    NA
)
expect_identical(
    fparse(js, c(na1 = NA_character_, na2 = NA_character_)),
    list(na1 = NA, na2 = NA)
)
expect_identical(
    fparse(js, list(NA_character_)),
    list(single_json = list(NA))
)
expect_identical(
    fparse(js, list(na = NA_character_)),
    list(na = list(NA))
)

#* flat query ------------------------------------------------------------------
#** single query ---------------------------------------------------------------
expect_identical(
    fparse(js, query = "/0/a/0"),
    1:2
)
expect_identical(
    fparse(js, query = c(a = "/0/a/0")),
    1:2
)
expect_identical(
    fparse(js, query = "/1/b/1"),
    7:8
)
#** multi query ----------------------------------------------------------------
expect_identical(
    fparse(js, query = c("/0/a/0", "/1/b/1")),
    list(1:2, 7:8)
)
expect_identical(
    fparse(js, query = c(a = "/0/a/0", b = "/1/b/1")),
    list(a = 1:2, b = 7:8)
)

#* nested query ----------------------------------------------------------------
q <- list(c("/0/a/0", "/1/b/1"))
expect_identical(
    fparse(js, query = q),
    list(single_json = list(1:2, 7:8))
)
expect_identical(
    fparse(unname(js), query = q),
    list(list(1:2, 7:8))
)

q <- list(queries = c("/0/a/0", "/1/b/1"))
expect_identical(
    fparse(js, query = q),
    list(queries = list(1:2, 7:8))
)

q <- list(c(a = "/0/a/0", b = "/1/b/1"))
expect_identical(
    fparse(js, query = q),
    list(single_json = list(a = 1:2, b = 7:8))
)
expect_identical(
    fparse(unname(js), query = q),
    list(list(a = 1:2, b = 7:8))
)

q <- list(queries = c(a = "/0/a/0", b = "/1/b/1"))
expect_identical(
    fparse(js, query = q),
    list(queries = list(a = 1:2, b = 7:8))
)

#** multi query ----------------------------------------------------------------
q <- list(c("/0/a/0", "/0/a/1"))
target <- list(single_json = list(1:2, 3:4))
expect_identical(
    fparse(js, query = q),
    target
)
expect_identical(
    fparse(unname(js), query = q),
    unname(target)
)

q <- list(queries = c(a1 = "/0/a/0", a2 = "/0/a/1",
                      b1 = "/1/b/0", b2 = "/1/b/1"))
expect_identical(
    fparse(js, query = q),
    list(queries = list(a1 = 1:2, a2 = 3:4, b1 = 5:6, b2 = 7:8))
)

# multi json ===================================================================

js <- c(A = '{"a":[[1,2],[3,4]]}', B = '{"a":[[5,6],[7,8]]}')
#* flat query ------------------------------------------------------------------
#** single query ---------------------------------------------------------------
expect_identical(
    fparse(js, query = "/a/0"),
    list(A = 1:2, B = 5:6)
)
#** multi query ----------------------------------------------------------------
expect_identical(
    fparse(js, query = c("/a/0", "/a/1")),
    list(A = list(1:2, 3:4), B = list(5:6, 7:8))
)
expect_identical(
    fparse(js, query = c(a = "/a/0", b = "/a/1")),
    list(A = list(a = 1:2, b = 3:4), B = list(a = 5:6, b = 7:8))
)

#* nested query ----------------------------------------------------------------
js <- c(A = '{"a":[[1,2],[3,4]]}', B = '{"b":[[5,6],[7,8]]}')
q <- list(c("/a/0", "/a/1"),
          c("/b/1", "/b/0"))
expect_identical(
    fparse(js, query = q),
    list(A = list(1:2, 3:4), B = list(7:8, 5:6))
)

q <- list(a = c("/a/0", "/a/1"),
          b = c("/b/1", "/b/0"))
expect_identical(
    fparse(js, query = q),
    list(a = list(1:2, 3:4), b = list(7:8, 5:6))
)

q <- list(a = c(a1 = "/a/0", a2 = "/a/1"),
          b = c(b1 = "/b/0", b2 = "/b/1"))
expect_identical(
    fparse(js, query = q),
    list(a = list(a1 = 1:2, a2 = 3:4), b = list(b1 = 5:6, b2 = 7:8))
)

q <- list(a = c(a1 = "/a/0", a2 = "/a/1"),
          b = c(b1 = "/b/0", b2 = "/b/1"))
expect_identical(
    fparse(js, query = q),
    list(a = list(a1 = 1:2, a2 = 3:4), b = list(b1 = 5:6, b2 = 7:8))
)

if (RcppSimdJson:::.unsupportedArchitecture()) exit_file("Unsupported chipset")

library(RcppSimdJson)

jsonfiles <- list.files("../jsonexamples", pattern="\\.json$", recursive=TRUE, full.names=TRUE)

expect_true(length(jsonfiles) >= 23)

sapply(jsonfiles, function(jf) expect_true(validateJSON(jf), info=jf))

expect_error(validateJSON("../jsonexamples/amazon_cellphones.ndjson"))
